Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::FilterIndexReader Class Reference

A FilterIndexReader contains another IndexReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class FilterIndexReader itself simply implements all abstract methods of IndexReader with versions that pass all requests to the contained index reader. Subclasses of FilterIndexReader may further override some of these methods and may also provide additional methods and fields. More...

`#include <FilterIndexReader.h>`

Inheritance diagram for Lucene::FilterIndexReader:

## Public Member Functions

| FilterIndexReader (const IndexReaderPtr &in)
| Construct a FilterIndexReader based on the specified base reader. Directory locking for delete, undeleteAll, and setNorm operations is left to the base reader. More...
virtual | ~FilterIndexReader ()
virtual String | getClassName ()
boost::shared_ptr< FilterIndexReader > | shared_from_this ()
virtual DirectoryPtr | directory ()
| Returns the directory associated with this index. The default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperation exception if one was not specified. More...
virtual Collection< TermFreqVectorPtr > | getTermFreqVectors (int32_t docNumber)

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored. More...

virtual TermFreqVectorPtr | getTermFreqVector (int32_t docNumber, const String &field)
| Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned. More...
virtual void | getTermFreqVector (int32_t docNumber, const String &field, const TermVectorMapperPtr &mapper)
| Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector. More...
virtual void | getTermFreqVector (int32_t docNumber, const TermVectorMapperPtr &mapper)
| Map all the term vectors for all fields in a Document. More...
virtual int32_t | numDocs ()
| Returns the number of documents in this index. More...
virtual int32_t | maxDoc ()
| Returns one greater than the largest possible document number. This may be used to, eg., determine how big to allocate an array which will have an element for every document number in an index. More...
virtual DocumentPtr | document (int32_t n, const FieldSelectorPtr &fieldSelector)

Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying FieldsReader) is closed before the lazy Field is loaded an exception may be thrown. If you want the value of a lazy Field to be available after closing you must explicitly load it or fetch the Document again with a new loader. More...

virtual bool | isDeleted (int32_t n)
| Returns true if document n has been deleted. More...
virtual bool | hasDeletions ()
| Returns true if any documents have been deleted. More...
virtual bool | hasNorms (const String &field)
| Returns true if there are norms stored for this field. More...
virtual ByteArray | norms (const String &field)
| Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. More...
virtual void | norms (const String &field, ByteArray norms, int32_t offset)
| Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. More...
virtual TermEnumPtr | terms ()
| Returns an enumeration of all the terms in the index. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), TermEnum#next() must be called on the resulting enumeration before calling other methods such as TermEnum#term(). More...
virtual TermEnumPtr | terms (const TermPtr &t)
| Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. More...
virtual int32_t | docFreq (const TermPtr &t)
| Returns the number of documents containing the term t. More...
virtual TermDocsPtr | termDocs ()
| Returns an unpositioned TermDocs enumerator. More...
virtual TermDocsPtr | termDocs (const TermPtr &term)
| Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...
virtual TermPositionsPtr | termPositions ()
| Returns an unpositioned TermPositions enumerator. More...
virtual HashSet< String > | getFieldNames (FieldOption fieldOption)
| Get a list of unique field names that exist in this index and have the specified field option information. More...
virtual int64_t | getVersion ()
| Version number when this IndexReader was opened. Not implemented in the IndexReader base class. More...
virtual bool | isCurrent ()
| Check whether any new changes have occurred to the index since this reader was opened. More...
virtual bool | isOptimized ()
| Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class. More...
virtual Collection< IndexReaderPtr > | getSequentialSubReaders ()
| Returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers). More...
virtual LuceneObjectPtr | getFieldCacheKey ()
| If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key. More...
virtual LuceneObjectPtr | getDeletesCacheKey ()
| If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key. More...
Public Member Functions inherited from Lucene::IndexReader
| IndexReader ()
virtual | ~IndexReader ()
boost::shared_ptr< IndexReader > | shared_from_this ()
int32_t | getRefCount ()
| Returns the current refCount for this reader. More...
void | incRef ()

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding decRef, in a finally clause; otherwise the reader may never be closed. Note that close simply calls decRef(), which means that the IndexReader will not really be closed until decRef has been called for all outstanding references. More...

void | decRef ()
| Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed. More...
virtual IndexReaderPtr | reopen ()
| Refreshes an IndexReader if the index has changed since this instance was (re)opened. More...
virtual IndexReaderPtr | reopen (bool openReadOnly)
| Just like reopen(), except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned. More...
virtual IndexReaderPtr | reopen (const IndexCommitPtr &commit)
| Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Efficiently clones the IndexReader (sharing most internal state). More...
virtual LuceneObjectPtr | clone (bool openReadOnly, const LuceneObjectPtr &other=LuceneObjectPtr())
| Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader. More...
virtual MapStringString | getCommitUserData ()
| Retrieve the String userData optionally passed to IndexWriter::commit. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
int32_t | numDeletedDocs ()
| Returns the number of deleted documents. More...
virtual DocumentPtr | document (int32_t n)
| Returns the stored fields of the n'th Document in this index. More...
virtual bool | hasChanges ()
| Used for testing. More...
virtual void | setNorm (int32_t doc, const String &field, uint8_t value)
| Resets the normalization factor for the named field of the named document. The norm represents the product of the field's boost and its length normalization. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old. More...
virtual void | setNorm (int32_t doc, const String &field, double value)
| Resets the normalization factor for the named field of the named document. More...
virtual TermPositionsPtr | termPositions (const TermPtr &term)

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration. More...

virtual void | deleteDocument (int32_t docNum)
| Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the document method will result in an error. The presence of this document may still be reflected in the docFreq statistic, though this will be corrected eventually as the index is further modified. More...
virtual int32_t | deleteDocuments (const TermPtr &term)
| Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See deleteDocument(int) for information about when this deletion will become effective. More...
virtual void | undeleteAll ()
| Undeletes all documents currently marked as deleted in this index. More...
void | flush ()
void | flush (MapStringString commitUserData)
void | commit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
void | close ()
| Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called. More...
virtual IndexCommitPtr | getIndexCommit ()
| Return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file. More...
virtual int64_t | getUniqueTermCount ()
| Returns the number of unique terms (across all fields) in this reader. More...
virtual int32_t | getTermInfosIndexDivisor ()
| For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::IndexReader
static String | _getClassName ()
static IndexReaderPtr | open (const DirectoryPtr &directory)
| Returns a IndexReader reading the index in the given Directory, with readOnly = true. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, bool readOnly)
| Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, bool readOnly)
| Returns an IndexReader reading the index in the given IndexCommit. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom IndexDeletionPolicy. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader. More...
static int64_t | lastModified (const DirectoryPtr &directory2)
| Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use isCurrent() instead. More...
static int64_t | getCurrentVersion (const DirectoryPtr &directory)
| Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index. More...
static MapStringString | getCommitUserData (const DirectoryPtr &directory)
| Reads commitUserData, previously passed to IndexWriter#commit(MapStringString), from current index segments file. This will return null if IndexWriter#commit(MapStringString) has never been called for this index. More...
static bool | indexExists (const DirectoryPtr &directory)
| Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it. More...
static void | main (Collection< String > args)
| Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored. More...
static Collection< IndexCommitPtr > | listCommits (const DirectoryPtr &dir)

Returns all commit points that exist in the Directory. Normally, because the default is KeepOnlyLastCommitDeletionPolicy, there would be only one commit point. But if you're using a custom IndexDeletionPolicy then there could be many commits. Once you have a given commit, you can open a reader on it by calling IndexReader#open(IndexCommit,bool). There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array. More...

## Protected Member Functions

virtual void | doUndeleteAll ()
| Implements actual undeleteAll() in subclass. More...
virtual void | doSetNorm (int32_t doc, const String &field, uint8_t value)
| Implements setNorm in subclass. More...
virtual void | doDelete (int32_t docNum)
| Implements deletion of the document numbered docNum. Applications should call deleteDocument(int) or deleteDocuments(Term). More...
virtual void | doCommit (MapStringString commitUserData)
| Implements commit. More...
virtual void | doClose ()
| Implements close. More...
Protected Member Functions inherited from Lucene::IndexReader
void | ensureOpen ()
virtual void | acquireWriteLock ()
| Does nothing by default. Subclasses that require a write lock for index modifications must implement this method. More...
void | commit ()
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics). More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

IndexReaderPtr | in
Protected Attributes inherited from Lucene::IndexReader
bool | closed
bool | _hasChanges
int32_t | refCount
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Public Types inherited from Lucene::IndexReader
enum | FieldOption { FIELD_OPTION_ALL, FIELD_OPTION_INDEXED, FIELD_OPTION_STORES_PAYLOADS, FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS, FIELD_OPTION_UNINDEXED, FIELD_OPTION_INDEXED_WITH_TERMVECTOR, FIELD_OPTION_INDEXED_NO_TERMVECTOR, FIELD_OPTION_TERMVECTOR, FIELD_OPTION_TERMVECTOR_WITH_POSITION, FIELD_OPTION_TERMVECTOR_WITH_OFFSET, FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET }
| Constants describing field properties, for example used for IndexReader#getFieldNames(FieldOption). More...
Static Public Attributes inherited from Lucene::IndexReader
static const int32_t | DEFAULT_TERMS_INDEX_DIVISOR
Static Protected Member Functions inherited from Lucene::IndexReader
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, const IndexCommitPtr &commit, bool readOnly, int32_t termInfosIndexDivisor)

## Detailed Description

A FilterIndexReader contains another IndexReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class FilterIndexReader itself simply implements all abstract methods of IndexReader with versions that pass all requests to the contained index reader. Subclasses of FilterIndexReader may further override some of these methods and may also provide additional methods and fields.

## Constructor & Destructor Documentation

## ◆ FilterIndexReader()

Lucene::FilterIndexReader::FilterIndexReader | ( | const IndexReaderPtr & | in | ) |

Construct a FilterIndexReader based on the specified base reader. Directory locking for delete, undeleteAll, and setNorm operations is left to the base reader.

Note that base reader is closed if this FilterIndexReader is closed.

Parameters

  in | specified base reader.

## ◆ ~FilterIndexReader()

virtual Lucene::FilterIndexReader::~FilterIndexReader | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::FilterIndexReader::_getClassName | ( |  | ) |

inline static

## ◆ directory()

virtual DirectoryPtr Lucene::FilterIndexReader::directory | ( |  | ) |

virtual

Returns the directory associated with this index. The default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperation exception if one was not specified.

Reimplemented from Lucene::IndexReader.

## ◆ docFreq()

virtual int32_t Lucene::FilterIndexReader::docFreq | ( | const TermPtr & | t | ) |

virtual

Returns the number of documents containing the term t.

Implements Lucene::IndexReader.

## ◆ doClose()

virtual void Lucene::FilterIndexReader::doClose | ( |  | ) |

protected virtual

Implements close.

Implements Lucene::IndexReader.

## ◆ doCommit()

virtual void Lucene::FilterIndexReader::doCommit | ( | MapStringString | commitUserData | ) |

protected virtual

Implements commit.

Implements Lucene::IndexReader.

## ◆ document()

virtual DocumentPtr Lucene::FilterIndexReader::document | ( | int32_t | n,
|  | const FieldSelectorPtr & | fieldSelector
| ) |  |

virtual

Get the Document at the n'th position. The FieldSelector may be used to determine what Fields to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying FieldsReader) is closed before the lazy Field is loaded an exception may be thrown. If you want the value of a lazy Field to be available after closing you must explicitly load it or fetch the Document again with a new loader.

NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call isDeleted(int32_t) with the requested document ID to verify the document is not deleted.

Parameters

  n | Get the document at the n'th position
  fieldSelector | The FieldSelector to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.

Returns
  The stored fields of the Document at the n'th position

See also
  Fieldable
  FieldSelector
  SetBasedFieldSelector
  LoadFirstFieldSelector

Implements Lucene::IndexReader.

## ◆ doDelete()

virtual void Lucene::FilterIndexReader::doDelete | ( | int32_t | docNum | ) |

protected virtual

Implements deletion of the document numbered docNum. Applications should call deleteDocument(int) or deleteDocuments(Term).

Implements Lucene::IndexReader.

## ◆ doSetNorm()

virtual void Lucene::FilterIndexReader::doSetNorm | ( | int32_t | doc,
|  | const String & | field,
|  | uint8_t | value
| ) |  |

protected virtual

Implements setNorm in subclass.

Implements Lucene::IndexReader.

## ◆ doUndeleteAll()

virtual void Lucene::FilterIndexReader::doUndeleteAll | ( |  | ) |

protected virtual

Implements actual undeleteAll() in subclass.

Implements Lucene::IndexReader.

## ◆ getClassName()

virtual String Lucene::FilterIndexReader::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::IndexReader.

## ◆ getDeletesCacheKey()

virtual LuceneObjectPtr Lucene::FilterIndexReader::getDeletesCacheKey | ( |  | ) |

virtual

If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key.

Reimplemented from Lucene::IndexReader.

## ◆ getFieldCacheKey()

virtual LuceneObjectPtr Lucene::FilterIndexReader::getFieldCacheKey | ( |  | ) |

virtual

If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key.

Reimplemented from Lucene::IndexReader.

## ◆ getFieldNames()

virtual HashSet<String> Lucene::FilterIndexReader::getFieldNames | ( | FieldOption | fieldOption | ) |

virtual

Get a list of unique field names that exist in this index and have the specified field option information.

Parameters

  fieldOption | specifies which field option should be available for the returned fields

Returns
  Collection of Strings indicating the names of the fields.

Implements Lucene::IndexReader.

## ◆ getSequentialSubReaders()

virtual Collection<IndexReaderPtr> Lucene::FilterIndexReader::getSequentialSubReaders | ( |  | ) |

virtual

Returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).

NOTE: You should not try using sub-readers returned by this method to make any changes (setNorm, deleteDocument, etc.). While this might succeed for one composite reader (like MultiReader), it will most likely lead to index corruption for other readers (like DirectoryReader obtained through open. Use the parent reader directly.

Reimplemented from Lucene::IndexReader.

## ◆ getTermFreqVector() [1/3]

virtual TermFreqVectorPtr Lucene::FilterIndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field
| ) |  |

virtual

Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionVector is returned.

Parameters

  docNumber | document for which the term frequency vector is returned.
  field | field for which the term frequency vector is returned.

Returns
  term frequency vector May be null if field does not exist in the specified document or term vector was not stored.

Implements Lucene::IndexReader.

## ◆ getTermFreqVector() [2/3]

virtual void Lucene::FilterIndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field,
|  | const TermVectorMapperPtr & | mapper
| ) |  |

virtual

Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the TermFreqVector.

Parameters

  docNumber | The number of the document to load the vector for
  field | The name of the field to load
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implements Lucene::IndexReader.

## ◆ getTermFreqVector() [3/3]

virtual void Lucene::FilterIndexReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const TermVectorMapperPtr & | mapper
| ) |  |

virtual

Map all the term vectors for all fields in a Document.

Parameters

  docNumber | The number of the document to load the vector for
  mapper | The TermVectorMapper to process the vector. Must not be null.

Implements Lucene::IndexReader.

## ◆ getTermFreqVectors()

virtual Collection<TermFreqVectorPtr> Lucene::FilterIndexReader::getTermFreqVectors | ( | int32_t | docNumber | ) |

virtual

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type TermFreqVector or of type TermPositionVector if positions or offsets have been stored.

Parameters

  docNumber | document for which term frequency vectors are returned

Returns
  array of term frequency vectors. May be null if no term vectors have been stored for the specified document.

Implements Lucene::IndexReader.

## ◆ getVersion()

virtual int64_t Lucene::FilterIndexReader::getVersion | ( |  | ) |

virtual

Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

If this reader is based on a Directory (ie, was created by calling open, or reopen on a reader based on a Directory), then this method returns the version recorded in the commit that the reader opened. This version is advanced every time IndexWriter#commit is called.

If instead this reader is a near real-time reader (ie, obtained by a call to IndexWriter#getReader, or by calling reopen on a near real-time reader), then this method returns the version of the last commit done by the writer. Note that even as further changes are made with the writer, the version will not changed until a commit is completed. Thus, you should not rely on this method to determine when a near real-time reader should be opened. Use isCurrent instead.

Reimplemented from Lucene::IndexReader.

## ◆ hasDeletions()

virtual bool Lucene::FilterIndexReader::hasDeletions | ( |  | ) |

virtual

Returns true if any documents have been deleted.

Implements Lucene::IndexReader.

## ◆ hasNorms()

virtual bool Lucene::FilterIndexReader::hasNorms | ( | const String & | field | ) |

virtual

Returns true if there are norms stored for this field.

Reimplemented from Lucene::IndexReader.

## ◆ isCurrent()

virtual bool Lucene::FilterIndexReader::isCurrent | ( |  | ) |

virtual

Check whether any new changes have occurred to the index since this reader was opened.

If this reader is based on a Directory (ie, was created by calling open, or reopen on a reader based on a Directory), then this method checks if any further commits (see IndexWriter#commit have occurred in that directory).

If instead this reader is a near real-time reader (ie, obtained by a call to IndexWriter#getReader, or by calling reopen on a near real-time reader), then this method checks if either a new commit has occurred, or any new uncommitted changes have taken place via the writer. Note that even if the writer has only performed merging, this method will still return false.

In any event, if this returns false, you should call reopen to get a new reader that sees the changes.

Reimplemented from Lucene::IndexReader.

## ◆ isDeleted()

virtual bool Lucene::FilterIndexReader::isDeleted | ( | int32_t | n | ) |

virtual

Returns true if document n has been deleted.

Implements Lucene::IndexReader.

## ◆ isOptimized()

virtual bool Lucene::FilterIndexReader::isOptimized | ( |  | ) |

virtual

Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.

Returns
  true if the index is optimized; false otherwise

Reimplemented from Lucene::IndexReader.

## ◆ maxDoc()

virtual int32_t Lucene::FilterIndexReader::maxDoc | ( |  | ) |

virtual

Returns one greater than the largest possible document number. This may be used to, eg., determine how big to allocate an array which will have an element for every document number in an index.

Implements Lucene::IndexReader.

## ◆ norms() [1/2]

virtual ByteArray Lucene::FilterIndexReader::norms | ( | const String & | field | ) |

virtual

Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

See also
  Field::setBoost(double)

Implements Lucene::IndexReader.

## ◆ norms() [2/2]

virtual void Lucene::FilterIndexReader::norms | ( | const String & | field,
|  | ByteArray | norms,
|  | int32_t | offset
| ) |  |

virtual

Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

See also
  Field::setBoost(double)

Implements Lucene::IndexReader.

## ◆ numDocs()

virtual int32_t Lucene::FilterIndexReader::numDocs | ( |  | ) |

virtual

Returns the number of documents in this index.

Implements Lucene::IndexReader.

## ◆ shared_from_this()

boost::shared_ptr< FilterIndexReader > Lucene::FilterIndexReader::shared_from_this | ( |  | ) |

inline

## ◆ termDocs() [1/2]

virtual TermDocsPtr Lucene::FilterIndexReader::termDocs | ( |  | ) |

virtual

Returns an unpositioned TermDocs enumerator.

Implements Lucene::IndexReader.

## ◆ termDocs() [2/2]

virtual TermDocsPtr Lucene::FilterIndexReader::termDocs | ( | const TermPtr & | term | ) |

virtual

Returns an enumeration of all the documents which contain term. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

Reimplemented from Lucene::IndexReader.

## ◆ termPositions()

virtual TermPositionsPtr Lucene::FilterIndexReader::termPositions | ( |  | ) |

virtual

Returns an unpositioned TermPositions enumerator.

Implements Lucene::IndexReader.

## ◆ terms() [1/2]

virtual TermEnumPtr Lucene::FilterIndexReader::terms | ( |  | ) |

virtual

Returns an enumeration of all the terms in the index. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), TermEnum#next() must be called on the resulting enumeration before calling other methods such as TermEnum#term().

Implements Lucene::IndexReader.

## ◆ terms() [2/2]

virtual TermEnumPtr Lucene::FilterIndexReader::terms | ( | const TermPtr & | t | ) |

virtual

Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term::compareTo(). Each term is greater than all that precede it in the enumeration.

Implements Lucene::IndexReader.

## Field Documentation

## ◆ in

IndexReaderPtr Lucene::FilterIndexReader::in

protected

The documentation for this class was generated from the following file:

- FilterIndexReader.h

clucene.sourceforge.net